// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once

#include "ISCW_FEdGraphPinType.h"
#include <memory>
#include <string>

using std::shared_ptr;
using std::wstring;

namespace Sourcify
{	
	class ISCW_FUserPinInfo
	{
	public:
		virtual ~ISCW_FUserPinInfo() = default;
		
		virtual ISCW_FEdGraphPinTypePtr GetPinType() const = 0;

		virtual wstring GetPinDefaultValue() const = 0;
		virtual void SetPinDefaultValue(const wstring& InDefaultValue) = 0;

		virtual shared_ptr<ISCW_FUserPinInfo> ToFUserPinInfoPtr() = 0;
		virtual shared_ptr<const ISCW_FUserPinInfo> ToFUserPinInfoPtr() const = 0;
	};

	using ISCW_FUserPinInfoConstPtr = shared_ptr<const ISCW_FUserPinInfo>;
	using ISCW_FUserPinInfoPtr = shared_ptr<ISCW_FUserPinInfo>;
} // namespace Sourcify